rm(list=ls())
##############################
#### gauss hermit intergration
##############################

int=function(f1){

z=c(0.2453407083009, 0.7374737285454, 1.2340762153953, 1.7385377121166, 2.2549740020893, 
2.7888060584281, 3.3478545673832, 3.9447640401156, 4.6036824495507, 5.3874808900112, 
-0.2453407083009,-0.7374737285454,-1.2340762153953,-1.7385377121166,-2.2549740020893,
-2.7888060584281,-3.3478545673832,-3.9447640401156,-4.6036824495507,-5.3874808900112)
a=c(4.622436696006e-1,2.866755053628e-1,1.090172060200e-1,2.481052088746e-2,3.243773342238e-3,
2.283386360163e-4,7.802556478532e-6,1.086069370769e-7,4.399340992273e-10,2.229393645534e-13,     
4.622436696006e-1,2.866755053628e-1,1.090172060200e-1,2.481052088746e-2,3.243773342238e-3,
2.283386360163e-4,7.802556478532e-6,1.086069370769e-7,4.399340992273e-10,2.229393645534e-13)

ans=sum((f1(z))*exp(z^2/2)*a/sqrt(2*pi))

return(ans)

}

#########
### W_ij, ith subject and jth outcome
#########

WW=function(x, data, yhat, param, i, j){

my=dim(data$yy)[2]
mx=dim(data$xx)[2]
mz=dim(data$zz)[2]

beta=param$beta
gamma=param$gamma
alpha=param$alpha

cc= sum(beta[(1+(j-1)*mx):(j*mx)]*data$xx[i,])+alpha[j]*(sum(gamma*data$zz[i,])+x)

ww=yhat[i]-cc

return(ww)

}

########################
# discrete W-ij strat
########################
yhat1=function(yhat){

### if yhat(j) is discrete ##
y1=sort(unique(yhat))
n=length(y1)
m1=match(yhat, y1)
y2=c(-99999, y1)[1:n]

return(y2[m1])

}

#############
### int F(x)
###############

intF=function(data, yhat, param){

n=dim(data$yy)[1]
mx=dim(data$xx)[2]

beta=param$beta
gamma=param$gamma
alpha=param$alpha

y3=yhat1(yhat[,3])
y4=yhat1(yhat[,4])

fi=rep(NA, n)
fb1=rep(NA, n)
fb2=fb3=fb4=rep(NA, n)
fa1=rep(NA, n)
fa2=fa3=fa4=rep(NA, n)

for(i in 1:n){

w1=function(x){
WW(x, data, yhat[,1], param, i, 1)
}

w2=function(x){
WW(x, data, yhat[,2], param, i, 2)
}

w3a=function(x){
WW(x, data, y3, param, i, 3)
}

w3=function(x){
WW(x, data, yhat[,3], param, i, 3)
}

w4a=function(x){
WW(x, data, y4, param, i, 4)
}

w4=function(x){
WW(x, data, yhat[,4], param, i, 4)
}

ans=function(x){
dnorm(w1(x))*dnorm(w2(x))*(pnorm(w3(x))-pnorm(w3a(x)))*(pnorm(w4(x))-pnorm(w4a(x)))
}

fi[i]=int(ans)

ans=function(x){
dnorm(w1(x))*dnorm(w2(x))*(pnorm(w3(x))-pnorm(w3a(x)))*(pnorm(w4(x))-pnorm(w4a(x)))*w1(x)
}
fb1[i]=int(ans)

ans=function(x){
dnorm(w1(x))*dnorm(w2(x))*(pnorm(w3(x))-pnorm(w3a(x)))*(pnorm(w4(x))-pnorm(w4a(x)))*w2(x)
}
fb2[i]=int(ans)

ans=function(x){
dnorm(w1(x))*dnorm(w2(x))*(dnorm(w3(x))-dnorm(w3a(x)))*(pnorm(w4(x))-pnorm(w4a(x)))
}
fb3[i]=int(ans)

ans=function(x){
dnorm(w1(x))*dnorm(w2(x))*(pnorm(w3(x))-pnorm(w3a(x)))*(dnorm(w4(x))-dnorm(w4a(x)))
}
fb4[i]=int(ans)

ans=function(x){
dnorm(w1(x))*dnorm(w2(x))*(pnorm(w3(x))-pnorm(w3a(x)))*(pnorm(w4(x))-pnorm(w4a(x)))*w1(x)*x
}
fa1[i]=int(ans)

ans=function(x){
dnorm(w1(x))*dnorm(w2(x))*(pnorm(w3(x))-pnorm(w3a(x)))*(pnorm(w4(x))-pnorm(w4a(x)))*w2(x)*x
}
fa2[i]=int(ans)

ans=function(x){
dnorm(w1(x))*dnorm(w2(x))*(dnorm(w3(x))-dnorm(w3a(x)))*(pnorm(w4(x))-pnorm(w4a(x)))*x
}
fa3[i]=int(ans)

ans=function(x){
dnorm(w1(x))*dnorm(w2(x))*(pnorm(w3(x))-pnorm(w3a(x)))*(dnorm(w4(x))-dnorm(w4a(x)))*x
}
fa4[i]=int(ans)

##w1f=function(x){dnorm(w1(x))}

##w2f=function(x){pnorm(w2(x))-pnorm(w2a(x))}

##cc1=sum(beta[(1:mx)]*t(data$xx[i,]))+alpha[1]*(sum(gamma*t(data$zz[i,])))

##ww1=yhat[i,1]-cc1
##cc2=sum(beta[(mx+1):(2*mx)]*t(data$xx[i,]))+alpha[2]*(sum(gamma*t(data$zz[i,])))

##ww2=yhat[i,2]-cc2
##ww3=y2[i]-cc2


###print(c(i, fi[i], fb1[i], fb2[i], fa1[i], fa2[i]))

}
return(list(fi=fi, fb1=fb1, fb2=fb2, fb3=fb3, fb4=fb4, fa1=fa1, fa2=fa2, fa3=fa3, fa4=fa4))

}

##################
#### calculate deruivatives and information matrix
####################

derivative.f=function(data, param, ff, wei){


n=dim(data$yy)[1]
vb11=vb12=vb21=vb22=
vb31=vb32=vb41=vb42=
va1=va2=va3=va4=vg1=rep(0,n)
### beta
for(i in 1:n){

if((ff$fi[i]==0)&(abs(ff$fb1[i])<1e-5))
{vb11[i]=data$xx[i,1]*(sign(ff$fb1[i])==0)+data$xx[i,1]*(sign(ff$fb1[i])!=0)*sign(ff$fb1[i])
 vb12[i]=data$xx[i,2]*(sign(ff$fb1[i])==0)+data$xx[i,2]*(sign(ff$fb1[i])!=0)*sign(ff$fb1[i])
} else
{vb11[i]=ff$fb1[i]*data$xx[i,1]/ff$fi[i]
vb12[i]=ff$fb1[i]*data$xx[i,2]/ff$fi[i]
}

if((ff$fi[i]==0)&(abs(ff$fb2[i])<1e-5))
{vb21[i]=data$xx[i,1]*(sign(ff$fb2[i])==0)+data$xx[i,1]*(sign(ff$fb2[i])!=0)*sign(ff$fb2[i])
 vb22[i]=data$xx[i,2]*(sign(ff$fb2[i])==0)+data$xx[i,2]*(sign(ff$fb2[i])!=0)*sign(ff$fb2[i])
} else
{vb21[i]=ff$fb2[i]*data$xx[i,1]/ff$fi[i]
vb22[i]=ff$fb2[i]*data$xx[i,2]/ff$fi[i]
}

if(((ff$fi[i]==0)&(abs(ff$fb3[i])<1e-5))|((abs(ff$fi[i])<1e-5)&(ff$fb3[i]==0)))
{vb31[i]=-data$xx[i,1]*(sign(ff$fb3[i])==0)-data$xx[i,1]*(sign(ff$fb3[i])!=0)*sign(ff$fb3[i])
 vb32[i]=-data$xx[i,2]*(sign(ff$fb3[i])==0)-data$xx[i,2]*(sign(ff$fb3[i])!=0)*sign(ff$fb3[i])
} else
{vb31[i]= - ff$fb3[i]*data$xx[i,1]/ff$fi[i]
vb32[i]= -(ff$fb3[i]*data$xx[i,2]/ff$fi[i])
}

if(((ff$fi[i]==0)&(abs(ff$fb4[i])<1e-5))|((abs(ff$fi[i])<1e-5)&(ff$fb4[i]==0)))
{vb41[i]=-data$xx[i,1]*(sign(ff$fb4[i])==0)-data$xx[i,1]*(sign(ff$fb4[i])!=0)*sign(ff$fb4[i])
 vb42[i]=-data$xx[i,2]*(sign(ff$fb4[i])==0)-data$xx[i,2]*(sign(ff$fb4[i])!=0)*sign(ff$fb4[i])
} else
{vb41[i]= - ff$fb4[i]*data$xx[i,1]/ff$fi[i]
vb42[i]= -(ff$fb4[i]*data$xx[i,2]/ff$fi[i])
}


### alpha
if((ff$fi[i]==0)&(abs(ff$fa1[i])<1e-5)&(abs(ff$fb1[i])<1e-5))
{
va1[i]=(sign(ff$fa1[i])==0)+(sign(ff$fa1[i])!=0)*sign(ff$fa1[i])+
       data$zz[i]*param$gamma*(sign(ff$fb1[i])==0)+data$zz[i]*param$gamma*(sign(ff$fb1[i])!=0)*sign(ff$fb1[i])
} else
{va1[i]=ff$fa1[i]/ff$fi[i] + ff$fb1[i]*data$zz[i]*param$gamma/ff$fi[i]}

if((ff$fi[i]==0)&(abs(ff$fa2[i])<1e-5)&(abs(ff$fb2[i])<1e-5))
{
va2[i]=(sign(ff$fa2[i])==0)+(sign(ff$fa2[i])!=0)*sign(ff$fa2[i])+
       data$zz[i]*param$gamma*(sign(ff$fb2[i])==0)+data$zz[i]*param$gamma*(sign(ff$fb2[i])!=0)*sign(ff$fb2[i])
} else
{va2[i]=ff$fa2[i]/ff$fi[i] + ff$fb2[i]*data$zz[i]*param$gamma/ff$fi[i]}


if(((ff$fi[i]==0)&(abs(ff$fa3[i])<1e-5)&(abs(ff$fb3[i])<1e-5))|((ff$fi[i]<1e-5)&(ff$fa3[i]==0)&(ff$fb3[i]==0)))
{va3[i]=-(sign(ff$fa3[i])==0)-(sign(ff$fa3[i])!=0)*sign(ff$fa3[i])-
       data$zz[i]*param$gamma*(sign(ff$fb3[i])==0)-data$zz[i]*param$gamma*(sign(ff$fb3[i])!=0)*sign(ff$fb3[i])

} else
{
va3[i]=-(ff$fa3[i]/ff$fi[i]+ff$fb3[i]*data$zz[i]*param$gamma/ff$fi[i])
}

if(((ff$fi[i]==0)&(abs(ff$fa4[i])<1e-5)&(abs(ff$fb4[i])<1e-5))|((ff$fi[i]<1e-5)&(ff$fa4[i]==0)&(ff$fb4[i]==0)))
{va4[i]=-(sign(ff$fa4[i])==0)-(sign(ff$fa4[i])!=0)*sign(ff$fa4[i])-
       data$zz[i]*param$gamma*(sign(ff$fb4[i])==0)-data$zz[i]*param$gamma*(sign(ff$fb4[i])!=0)*sign(ff$fb4[i])

} else
{
va4[i]=-(ff$fa4[i]/ff$fi[i]+ff$fb4[i]*data$zz[i]*param$gamma/ff$fi[i])
}

## gamma
if(((ff$fi[i]==0)&(abs(ff$fb1[i])<1e-5)&(abs(ff$fb2[i])<1e-5)&(abs(ff$fb3[i])<1e-5)&(abs(ff$fb4[i])<1e-5))|
   ((ff$fi[i]<1e-5)&(abs(ff$fb1[i])<1e-5)&(abs(ff$fb2[i])<1e-5)&(ff$fb3[i]==0)&(ff$fb4[i]==0)))
{vg1[i]=data$zz[i]*param$alpha[1]*(sign(ff$fb1[i])==0)+
        data$zz[i]*param$alpha[1]*(sign(ff$fb1[i])!=0)*sign(ff$fb1[i])+
        data$zz[i]*param$alpha[2]*(sign(ff$fb2[i])==0)+
        data$zz[i]*param$alpha[2]*(sign(ff$fb2[i])!=0)*sign(ff$fb2[i])-
        data$zz[i]*param$alpha[3]*(sign(ff$fb3[i])==0)-
        data$zz[i]*param$alpha[3]*(sign(ff$fb3[i])!=0)*sign(ff$fb3[i])-
        data$zz[i]*param$alpha[4]*(sign(ff$fb4[i])==0)-
        data$zz[i]*param$alpha[4]*(sign(ff$fb4[i])!=0)*sign(ff$fb4[i])
} else
vg1[i]=(ff$fb1[i]*data$zz[i]*param$alpha[1]/ff$fi[i]+ff$fb2[i]*data$zz[i]*param$alpha[2]/ff$fi[i]-
        ff$fb3[i]*data$zz[i]*param$alpha[3]/ff$fi[i]-ff$fb4[i]*data$zz[i]*param$alpha[4]/ff$fi[i])

}

b11=sum(wei*vb11)
b12=sum(wei*vb12)
b21=sum(wei*vb21)
b22=sum(wei*vb22)
b31=sum(wei*vb31)
b32=sum(wei*vb32)
b41=sum(wei*vb41)
b42=sum(wei*vb42)
a1=sum(wei*va1)
a2=sum(wei*va2)
a3=sum(wei*va3)
a4=sum(wei*va4)
g1=sum(wei*vg1)

### information

ib11b11=sum(wei*vb11*vb11)
ib11b12=sum(wei*vb11*vb12)
ib11b21=sum(wei*vb11*vb21)
ib11b22=sum(wei*vb11*vb22)
ib11b31=sum(wei*vb11*vb31)
ib11b32=sum(wei*vb11*vb32)
ib11b41=sum(wei*vb11*vb41)
ib11b42=sum(wei*vb11*vb42)
ib11a1=sum(wei*vb11*va1)
ib11a2=sum(wei*vb11*va2)
ib11a3=sum(wei*vb11*va3)
ib11a4=sum(wei*vb11*va4)
ib11g1=sum(wei*vb11*vg1)

ib12b12=sum(wei*vb12*vb12)
ib12b21=sum(wei*vb12*vb21)
ib12b22=sum(wei*vb12*vb22)
ib12b31=sum(wei*vb12*vb31)
ib12b32=sum(wei*vb12*vb32)
ib12b41=sum(wei*vb12*vb41)
ib12b42=sum(wei*vb12*vb42)
ib12a1=sum(wei*vb12*va1)
ib12a2=sum(wei*vb12*va2)
ib12a3=sum(wei*vb12*va3)
ib12a4=sum(wei*vb12*va4)
ib12g1=sum(wei*vb12*vg1)

ib21b21=sum(wei*vb21*vb21)
ib21b22=sum(wei*vb21*vb22)
ib21b31=sum(wei*vb21*vb31)
ib21b32=sum(wei*vb21*vb32)
ib21b41=sum(wei*vb21*vb41)
ib21b42=sum(wei*vb21*vb42)
ib21a1=sum(wei*vb21*va1)
ib21a2=sum(wei*vb21*va2)
ib21a3=sum(wei*vb21*va3)
ib21a4=sum(wei*vb21*va4)
ib21g1=sum(wei*vb21*vg1)

ib22b22=sum(wei*vb22*vb22)
ib22b31=sum(wei*vb22*vb31)
ib22b32=sum(wei*vb22*vb32)
ib22b41=sum(wei*vb22*vb41)
ib22b42=sum(wei*vb22*vb42)
ib22a1=sum(wei*vb22*va1)
ib22a2=sum(wei*vb22*va2)
ib22a3=sum(wei*vb22*va3)
ib22a4=sum(wei*vb22*va4)
ib22g1=sum(wei*vb22*vg1)

ib31b31=sum(wei*vb31*vb31)
ib31b32=sum(wei*vb31*vb32)
ib31b41=sum(wei*vb31*vb41)
ib31b42=sum(wei*vb31*vb42)
ib31a1=sum(wei*vb31*va1)
ib31a2=sum(wei*vb31*va2)
ib31a3=sum(wei*vb31*va3)
ib31a4=sum(wei*vb31*va4)
ib31g1=sum(wei*vb31*vg1)

ib32b32=sum(wei*vb32*vb32)
ib32b41=sum(wei*vb32*vb41)
ib32b42=sum(wei*vb32*vb42)
ib32a1=sum(wei*vb32*va1)
ib32a2=sum(wei*vb32*va2)
ib32a3=sum(wei*vb32*va3)
ib32a4=sum(wei*vb32*va4)
ib32g1=sum(wei*vb32*vg1)

ib41b41=sum(wei*vb41*vb41)
ib41b42=sum(wei*vb41*vb42)
ib41a1=sum(wei*vb41*va1)
ib41a2=sum(wei*vb41*va2)
ib41a3=sum(wei*vb41*va3)
ib41a4=sum(wei*vb41*va4)
ib41g1=sum(wei*vb41*vg1)

ib42b42=sum(wei*vb42*vb42)
ib42a1=sum(wei*vb42*va1)
ib42a2=sum(wei*vb42*va2)
ib42a3=sum(wei*vb42*va3)
ib42a4=sum(wei*vb42*va4)
ib42g1=sum(wei*vb42*vg1)

ia1a1=sum(wei*va1*va1)
ia1a2=sum(wei*va1*va2)
ia1a3=sum(wei*va1*va3)
ia1a4=sum(wei*va1*va4)
ia1g1=sum(wei*va1*vg1)

ia2a2=sum(wei*va2*va2)
ia2a3=sum(wei*va2*va3)
ia2a4=sum(wei*va2*va4)
ia2g1=sum(wei*va2*vg1)

ia3a3=sum(wei*va3*va3)
ia3a4=sum(wei*va3*va4)
ia3g1=sum(wei*va3*vg1)

ia4a4=sum(wei*va4*va4)
ia4g1=sum(wei*va4*vg1)

ig1g1=sum(wei*vg1*vg1)

infm=matrix(c(ib11b11, ib11b12, ib11b21, ib11b22, ib11b31, ib11b32, ib11b41, ib11b42, ib11a1, ib11a2, ib11a3, ib11a4, ib11g1,
		  ib11b12, ib12b12, ib12b21, ib12b22, ib12b31, ib12b32, ib12b41, ib12b42, ib12a1, ib12a2, ib12a3, ib12a4, ib12g1,
		  ib11b21, ib12b21, ib21b21, ib21b22, ib21b31, ib21b32, ib21b41, ib21b42, ib21a1, ib21a2, ib21a3, ib21a4, ib21g1,
	        ib11b22, ib12b22, ib21b22, ib22b22, ib22b31, ib22b32, ib22b41, ib22b42, ib22a1, ib22a2, ib22a3, ib22a4, ib22g1,
              ib11b31, ib12b31, ib21b31, ib22b31, ib31b31, ib31b32, ib31b41, ib31b42, ib31a1, ib31a2, ib31a3, ib31a4, ib31g1,
              ib11b32, ib12b32, ib21b32, ib22b32, ib31b32, ib32b32, ib32b41, ib32b42, ib32a1, ib32a2, ib32a3, ib32a4, ib32g1,
              ib11b41, ib12b41, ib21b41, ib22b41, ib31b41, ib32b41, ib41b41, ib41b42, ib41a1, ib41a2, ib41a3, ib41a4, ib41g1,
              ib11b42, ib12b42, ib21b42, ib22b42, ib31b42, ib32b42, ib41b42, ib42b42, ib42a1, ib42a2, ib42a3, ib42a4, ib42g1,
		  ib11a1,  ib12a1,  ib21a1,  ib22a1,  ib31a1,  ib32a1,  ib41a1,  ib42a1,  ia1a1,  ia1a2,  ia1a3,  ia1a4,  ia1g1,
		  ib11a2,  ib12a2,  ib21a2,  ib22a2,  ib31a2,  ib32a2,  ib41a2,  ib42a2,  ia1a2,  ia2a2,  ia2a3,  ia2a4,  ia2g1,
		  ib11a3,  ib12a3,  ib21a3,  ib22a3,  ib31a3,  ib32a3,  ib41a3,  ib42a3,  ia1a3,  ia2a3,  ia3a3,  ia3a4,  ia3g1,
              ib11a4,  ib12a4,  ib21a4,  ib22a4,  ib31a4,  ib32a4,  ib41a4,  ib42a4,  ia1a4,  ia2a4,  ia3a4,  ia4a4,  ia4g1,
              ib11g1,  ib12g1,  ib21g1,  ib22g1,  ib31g1,  ib32g1,  ib41g1,  ib42g1,  ia1g1,  ia2g1,  ia3g1,  ia4g1,  ig1g1), nrow=13)

return(list(deriv=c(b11, b12, b21, b22, b31, b32, b41, b42, a1, a2, a3, a4, g1)/n, infm=infm/n))

}


#############
### parameter estimation with fisher scoring method 
#############

estimate.param=function(data, yhat, param, delta, wei){

d=delta+1
param1=param
i=0
while(d>delta){

ff=intF(data, yhat, param1)

#print(paste('loglik =', sum(log(ff$fi))))
deriv=derivative.f(data, param1, ff, wei)
v0=c(param1$beta, param1$alpha, param1$gamma)

if(!is.na(sum(deriv$infm))){

qrinfo=qr(deriv$infm, tol=1e-9)
if(qrinfo$rank <13){
v1=rep(NA, 13)
} else {
inv=qr.coef(qrinfo, diag(rep(1,13)))
v1=v0+c(inv%*%(deriv$deriv))
}

} else v1=rep(NA, 13)

param1$beta=v1[1:8]
param1$alpha=v1[9:12]
param1$gamma=v1[13]

if(is.na(v1[1])) 
{
print(sum(deriv$infm))
break
}
d=sum((v0-v1)^2)
#print('v1')
# print(v1)
#print('v0')
#print(v0)
# print(paste('d=', d))
i=i+1
if(d< delta | i> 20 ) 
{
print(paste('d=', d))
break
}

}

return(param1)

}


##############################################
### newton raphon to solve 3.4 for each unique y
##############################################

newton1=function(x0, cc, ss, mm, delta, wei){

d1=delta+1
s1=(x0-cc)/ss

while(d1 >delta){

xx=x0+(mm-sum(pnorm(s1)*wei))/sum(dnorm(s1)*wei/ss)
##print(sum(dnorm(s1)/ss))

x0=xx
s1=(x0-cc)/ss
##print(paste('x0=',x0, '  s1=',sum(dnorm(s1))))

d1=abs(mm-sum(pnorm(s1)*wei))
if(is.na(d1)){ break
}
}
##print(paste('dd=',d1))

return(x0)

}

#########################################
### estimate transformation given parameters
###############################################

estimate.yhat=function(data, param, delta, wei){

n=dim(data$yy)[1]
my=dim(data$yy)[2]
mx=dim(data$xx)[2]

yhat=matrix(NA, nrow=n, ncol=my)

beta=param$beta
gamma=param$gamma
alpha=param$alpha

## estimate of transformation
for( j in 1:my){

cc=(beta[(1+(j-1)*mx):(j*mx)]%*%t(data$xx)+alpha[j]*gamma%*%t(data$zz))
ss=sqrt(alpha[j]^2 +1)

## unique y
uu=sort(unique(data$yy[,j]))
nu=length(uu)

y2=rep(NA, nu)
#if(j==1) xs=min(log(data$yy[,j]))
#else xs=1
xs=sum(beta[(1+(j-1)*mx):(j*mx)])/2+alpha[j]*gamma/2

for(i in 1:(nu-1)){
mm=sum((data$yy[,j]<=uu[i])*wei)
###print(paste('i=',i,' j=',j))
if(i==1) y2[i]=newton1(xs, cc, ss, mm, delta, wei)
else y2[i]=newton1(y2[i-1], cc, ss, mm, delta, wei)

if(is.na(y2[i])) y2[i]=newton1(xs, cc, ss, mm, delta, wei)

if(is.na(y2[i])) 
{
print(paste("y2",i))
break

}
}

if(j==1|j==2) y2[nu]=y2[nu-1]
else 
{
y2[nu]=99999
#y2[1]=-99999
}
m1=match(data$yy[,j], uu)
yhat[,j]=y2[m1]

}
return(yhat)

}

######estimating final fixed-transformation function#####

estimate.yhat1=function(data1, data, param, delta, wei){

n=dim(data$yy)[1]
my=dim(data$yy)[2]
mx=dim(data$xx)[2]

yhat=matrix(NA, nrow=n, ncol=my)

beta=param$beta
gamma=param$gamma
alpha=param$alpha

## estimate of transformation
for( j in 1:my){

cc=(beta[(1+(j-1)*mx):(j*mx)]%*%t(data$xx)+alpha[j]*gamma%*%t(data$zz))
ss=sqrt(alpha[j]^2 +1)

## unique y
uu=sort(unique(data1$yy[,j]))
nu=length(uu)

y2=rep(NA, nu)
#if(j==1) xs=min(log(data1$yy[,j]))
#else xs=1
xs=sum(beta[(1+(j-1)*mx):(j*mx)])/2+alpha[j]*gamma/2

for(i in 1:(nu-1)){
mm=sum((data$yy[,j]<=uu[i])*wei)
###print(paste('i=',i,' j=',j))
if(i==1) y2[i]=newton1(xs, cc, ss, mm, delta, wei)
else y2[i]=newton1(y2[i-1], cc, ss, mm, delta, wei)

if(is.na(y2[i])) y2[i]=newton1(xs, cc, ss, mm, delta, wei)

if(is.na(y2[i])) 
{
print(paste("y2",i))
break

}
}

if(j==1|j==2) y2[nu]=y2[nu-1]
else 
{
y2[nu]=99999
#y2[1]=-99999
}
m1=match(data1$yy[,j], uu)
yhat[,j]=y2[m1]

}
return(yhat)

}

############## ####### ############################# ####### ####
## analysis: iteration between trasformation and parameter estimation
### ########### ########## ########### ######### ######### ######

analysis=function(data, param, delta, wei){

### data dimension
ydim=dim(data$yy)
xdim=dim(data$xx)
zdim=dim(data$zz)

##estimate hhat 

param.old=param

dd=delta+1
i=0
while(dd > delta){

print(paste('###', i, '###'))

yhat=estimate.yhat(data,  param.old, delta, wei)
#print(sort(unique(yhat[,3])))
#print(sort(unique(yhat[,4])))
if(is.na(sum(yhat[,1])) | is.na(sum(yhat[,2]))|is.na(sum(yhat[,3]))|is.na(sum(yhat[,4]))) {
param.old$beta=rep(NA,8)
param.old$alpha=rep(NA,4)
param.old$gamma=NA
break
}
print('## yhat ##')
#### estimate other parameters

param.new=estimate.param(data, yhat, param.old, delta, wei)

v0=c(param.old$beta, param.old$alpha, param.old$gamma)
v1=c(param.new$beta, param.new$alpha, param.new$gamma)
#print('v0')
#print(v0)
#print('v1')
#print(v1)

i=i+1
dd=sum((v0-v1)^2)
print(paste('dd=', dd))
param.old=param.new
if(i>150 | is.na(v1[1])) {
param.old$beta=rep(NA,8)
param.old$alpha=rep(NA,4)
param.old$gamma=NA
break
}

}

return(list(param=param.old, yhat=yhat))

}

###################

#### generating data
#####################

data1.gen=function(n, dimm, param, cutoff){

my=dimm$my
mx=dimm$mx
mz=dimm$mz

beta=param$beta
alpha=param$alpha
gamma=param$gamma

yy=matrix(NA, nrow=n, ncol=my)
## trandom effects
yr=matrix(NA, nrow=n, ncol=my)
xx=matrix(NA, nrow=n, ncol=mx)
zz=matrix(NA, nrow=n, ncol=mz)

### generate x
for(k in 1:mx){
xx[,k]=runif(n)
}

### generate z
for(k in 1:mz){
##zz[,k]=rbinom(n, 1, 0.3)
zz[,k]=runif(n)

}

### generate random effects

zr=apply(gamma*t(zz),2,sum) + rnorm(n)

### generate y1&y2

t1=apply(beta[1:mx]*t(xx),2, sum)+alpha[1]*zr+rnorm(n)
t2=apply(beta[(mx+1):(2*mx)]*t(xx),2, sum)+alpha[2]*zr+rnorm(n)
### transformation
yy[,1]=exp(t1)
yy[,2]=(1/2*t2+1)^2        #########box-cox########lambda=0.5######## 
### generate y3&y4

t3=apply(beta[(2*mx+1):(3*mx)]*t(xx),2,sum)+alpha[3]*zr+rnorm(n)
t4=apply(beta[(3*mx+1):(4*mx)]*t(xx),2,sum)+alpha[4]*zr+rnorm(n)
### transformation
cc=length(cutoff)
yy[,3]=1
yy[,4]=1
for(k in 1:cc){
yy[t3>cutoff[k] ,3]=k+1
yy[t4^(1/3)>cutoff[k]-1 ,4]=k+1

}
return(list(yy=yy, xx=xx, zz=zz))

}

#### simulation ####
sim1=function(n, dimm, param, delta=0.0001, cutoff, nsim,samp){

out=matrix(NA, nrow=nsim, ncol=13)
outy1=outy2=matrix(NA,nrow=nsim,ncol=n)

outy3=outy5=matrix(NA,nrow=nsim,ncol=5)
outy4=outy6=matrix(NA,nrow=nsim,ncol=3)
#vv=matrix(NA, nrow=nsim, ncol=7)

set.seed(samp)
data2=data1 = data1.gen(n, dimm, param, cutoff)
for(i in 1:nsim){
set.seed(i)
print(paste('### new sim ##########', i))
wei=rgamma(n,1,1)

out1 =analysis(data1, param, delta, wei)

out[i,]=c(out1$param$beta, out1$param$alpha, out1$param$gamma)
print(out1$param)
if(!is.na(sum(out1$yhat[,1]))&!is.na(sum(out1$yhat[,2]))){
outy3[i,]=sort(unique(out1$yhat[,3]))
outy4[i,]=sort(unique(out1$yhat[,4]))
print(outy3[i,])
print(outy4[i,])
}
}
return(list(out=out,outy1=outy1,outy2=outy2,outy3=outy3,outy4=outy4))

}

dimm=list(my=4, mx=2, mz=1)
param=list(beta=c(1.5,1.5,1,1,2,2,1,1), gamma=3, alpha=c(0.5, 0.5, 0.5, 0.5))
n=300
delta=0.001
cutoff=c(1,2,3,4)

#################read data##########3
theta=read.table("theta_e_ini_f0818.txt")
nrow(theta)

########mean#####
theta0=c(1.5,1.5,1,1,2,2,1,1,0.5,0.5,0.5,0.5,3)
theta[is.na(theta[,1]),]=9999
dd=apply((theta-outer(rep(1,nrow(theta)),theta0))^2,1,sum)
m1=match(sort(dd),dd)

s1=m1[nrow(theta)*0.1]
s2=m1[nrow(theta)*0.25]
s3=m1[nrow(theta)*0.5]
s4=m1[nrow(theta)*0.75]
s5=m1[nrow(theta)*0.9]

print(c(s1,s2,s3,s4,s5))

out1=sim1(n,dimm,param,delta,cutoff,nsim=500,s1)
write.table(out1$out,"b1_theta_f.txt")
write.table(out1$outy3,"b1_c_f.txt")
write.table(out1$outy4,"b1_c2_f.txt")

out2=sim1(n,dimm,param,delta,cutoff,nsim=500,s2)
write.table(out2$out,"b2_theta_f.txt")
write.table(out2$outy3,"b2_c_f.txt")
write.table(out2$outy4,"b2_c2_f.txt")

out3=sim1(n,dimm,param,delta,cutoff,nsim=500,s3)
write.table(out3$out,"b3_theta_f.txt")
write.table(out3$outy3,"b3_c_f.txt")
write.table(out3$outy4,"b3_c2_f.txt")

out4=sim1(n,dimm,param,delta,cutoff,nsim=500,s4)
write.table(out4$out,"b4_theta_f.txt")
write.table(out4$outy3,"b4_c_f.txt")
write.table(out4$outy4,"b4_c2_f.txt")

out5=sim1(n,dimm,param,delta,cutoff,nsim=500,s5)
write.table(out5$out,"b5_theta_f.txt")
write.table(out5$outy3,"b5_c_f.txt")
write.table(out5$outy4,"b5_c2_f.txt")
